function love.load()
	gamestate = "menu"
	background = newPaddedImage("graphics/background.png")
	whiteout = newPaddedImage("graphics/whiteout.png")
	scoreimage = newPaddedImage("graphics/score.png")
	football = {}
	football[1] = newPaddedImage("graphics/football1.png")
	football[2] = newPaddedImage("graphics/football2.png")
	football[3] = newPaddedImage("graphics/football3.png")
	football[4] = newPaddedImage("graphics/football4.png")
	player = {}
	player[1] = newPaddedImage("graphics/patheticperson.png")
	player[2] = newPaddedImage("graphics/patheticpersonshoot.png")
	hooker = {}
	hooker[1] = newPaddedImage("graphics/hooker.png")
	hooker[2] = newPaddedImage("graphics/hookerangry.png")
	pathetic = newPaddedImage("graphics/pathetic.png")
	font = newPaddedImageFont("graphics/font.png", "0123456789abcdefghijklmnopqrstTuvwxyz.,'C-#_ ")
	scorefont = newPaddedImageFont("graphics/scorefont.png", "0123456789")
	love.graphics.setFont(font)
	love.graphics.setMode( 480, 360)
	
	doop = love.audio.newSource("sounds/doop.ogg", "stream")
	doop:setVolume(0.5)
	doop:setLooping(true)
	love.audio.play(doop)
	
	kicksound = love.audio.newSource("sounds/kick.wav", "stream")
	ballplusface = love.audio.newSource("sounds/ballplusface.wav", "stream")
end

function endgame()
	gamestate = "end"
end

function love.update()
	currenttime = love.timer.getTime()
	if gamestate == "game" then
		value = currenttime - balltimer
		if value > 4 then
			balltimer = love.timer.getTime()
			count = count + 1
			if count >= 10 then
				endgame()
			end
		end
	end
	if gamestate == "ballflying" then
		xposflying = 290 + (currenttime - flytimer) * 140
		yposflying = 276 - (currenttime - flytimer) * 345
		if currenttime - flytimer > 0.60 then
			fallingtimer = currenttime
			gamestate = "ballfalling"
			score = score + 1
			love.audio.stop(ballplusface)
			love.audio.play(ballplusface)
		end
	end
	if gamestate == "ballfalling" then --pos is currently (374, 69)
		xposfalling = 374 + (currenttime - fallingtimer) * 400
		yposfalling = 69 + (currenttime - fallingtimer) * 140
		if math.mod(math.floor((currenttime - fallingtimer)*10+0.5), 2) == 0 then
			hookergraphic = hooker[2]
		else
			hookergraphic = hooker[1]
		end
		
		if currenttime - fallingtimer > 2.00 then
			count = count + 1
			if count >= 10 then
				endgame()
			end
			fallingtimer = currenttime
			balltimer = currenttime
			value = currenttime - balltimer
			if value > 4 then
				balltimer = love.timer.getTime()
			end
			gamestate = "game"
			hookergraphic = hooker[1]
		end
	end
		
	if gamestate == "game" or gamestate == "ballflying" or gamestate == "ballfalling" then
		if currenttime - shootdelaytimer > 0.5 then
			playergraphic = player[1]
		end
		if currenttime - animationtime > 0.1 then
			animationcounter = animationcounter + 1
			if animationcounter == 5 then animationcounter = 1 end
			animationtime = currenttime
		end
	end
end

function love.draw()
		love.graphics.setFont(font)
		love.graphics.draw(background, 0, 0)
	if gamestate == "menu" then
		love.graphics.draw(whiteout, 0, 0)
		love.graphics.printf( "shoot the hooker\n\n\n\n\n press x to shoot\n\n\n\n\npress enter to start", 0, 10, 480, "center" )
	elseif gamestate == "game" then
		love.graphics.draw(scoreimage, 4, 4)
		love.graphics.setFont(scorefont)
		love.graphics.print( tostring(score), 4, 36)
		love.graphics.draw(football[animationcounter], (3 - value) * 180-24, 252)
		love.graphics.draw(playergraphic, 224, 180)
		love.graphics.draw(hookergraphic, 350, 50)
	elseif gamestate == "ballflying" then
		love.graphics.draw(scoreimage, 4, 4)
		love.graphics.setFont(scorefont)
		love.graphics.print( tostring(score), 4, 36)
		love.graphics.draw(playergraphic, 224, 180)
		love.graphics.draw(hookergraphic, 350, 50)
		love.graphics.draw(football[animationcounter], xposflying-24, yposflying-24)
	elseif gamestate == "ballfalling" then
		love.graphics.draw(scoreimage, 4, 4)
		love.graphics.setFont(scorefont)
		love.graphics.print( tostring(score), 4, 36)
		love.graphics.draw(playergraphic, 224, 180)
		love.graphics.draw(hookergraphic, 350, 50)
		love.graphics.draw(pathetic, 100, 12)
		love.graphics.draw(football[animationcounter], xposfalling-24, yposfalling-24)
	elseif gamestate == "end" then
		love.graphics.draw(whiteout, 0, 0)
		if score == 10 then
			love.graphics.printf( "shoot the hooker\n\n\n\n\nyour score was "..score.."\nexcellent job\n\n\npress enter\nto restart", 0, 10, 480, "center" )
		else
			love.graphics.printf( "shoot the hooker\n\n\n\n\nyour score was "..score.."\n\n\n\npress enter\nto restart", 0, 10, 480, "center" )
		end
	end
end

function newPaddedImage(filename)
    local source = love.image.newImageData(filename)
    local w, h = source:getWidth(), source:getHeight()
   
    -- Find closest power-of-two.
    local wp = math.pow(2, math.ceil(math.log(w)/math.log(2)))
    local hp = math.pow(2, math.ceil(math.log(h)/math.log(2)))
   
    -- Only pad if needed:
    if wp ~= w or hp ~= h then
        local padded = love.image.newImageData(wp, hp)
        padded:paste(source, 0, 0)
        return love.graphics.newImage(padded)
    end
   
    return love.graphics.newImage(source)
end

function newPaddedImageFont(filename, glyphs)
    local source = love.image.newImageData(filename)
    local w, h = source:getWidth(), source:getHeight()
   
    -- Find closest power-of-two.
    local wp = math.pow(2, math.ceil(math.log(w)/math.log(2)))
    local hp = math.pow(2, math.ceil(math.log(h)/math.log(2)))
   
    -- Only pad if needed:
    if wp ~= w or hp ~= h then
        local padded = love.image.newImageData(wp, hp)
        padded:paste(source, 0, 0)
		local image = love.graphics.newImage(padded)
        return love.graphics.newImageFont(image, glyphs)
    end
   
    return love.graphics.newImageFont(source, glyphs)
end

function love.keypressed(key)
	if gamestate == "menu" and key == "return" then
		startgame()
	elseif gamestate == "game" and key == "x" then
		if love.timer.getTime() - shootdelaytimer > 0.5 then
			shoot()
			shootdelaytimer = currenttime
		end
	elseif gamestate == "end" and key == "return" then
		startgame()
	end
end

function shoot()
	playergraphic = player[2]
	if math.abs(value - 1.4) < 0.1 - (count)/100 then
		hit()
	end
end

function hit()
	love.audio.stop(kicksound)
	love.audio.play(kicksound)
	gamestate = "ballflying"
	flytimer = love.timer.getTime()
end

function startgame()
	score = 0
	count = 0
	animationcounter = 1
	playergraphic = player[1]
	hookergraphic = hooker[1]
	love.graphics.setFont(scorefont)
	balltimer = love.timer.getTime()
	animationtime = love.timer.getTime()
	shootdelaytimer = 0
	gamestate = "game"
end